//
//  SSTerminationViewController.m
//  Open
//
//  Created by 雷俊博 on 2019/7/26.
//  Copyright © 2019 黄江涛 . All rights reserved.
//

#import "SSTerminationViewController.h"
#import "Constants.h"
#import "UIColor+Hex.h"
#import "NSString+AttributedString.h"

#import "XZDrawView.h"
#import "CTAPIBaseManager.h"

//OCR
#import "IOSOCRAPI.h"
#import "SCCaptureCameraController.h"

@interface SSTerminationViewController ()<UITextFieldDelegate,SCNavigationControllerDelegate>

//背景图
@property (nonatomic, strong)XZDrawView *backView;
//姓名
@property (nonatomic, strong)UIView *backView_Name;
@property (nonatomic, strong)UIView *view_Name;
@property (nonatomic, strong)UIView *subView_Name;
@property (nonatomic, strong)UIImageView *img_Name;
@property (nonatomic, strong)UITextField *tf_Name;
//身份证号
@property (nonatomic, strong)UIView *backView_IDNumber;
@property (nonatomic, strong)UIView *view_IDNumber;
@property (nonatomic, strong)UIView *subView_IDNumber;
@property (nonatomic, strong)UIImageView *img_IDNumber;
@property (nonatomic, strong)UITextField *tf_IDNumber;
@property (nonatomic, strong)UIButton *btn_scan;

@property (nonatomic, strong)UILabel *lb_Example;
@property (nonatomic, strong)UIImageView *img_Example;


@property (nonatomic, strong)UIView *leftLine;
@property (nonatomic, strong)UIView *rightLine;

@property (nonatomic, strong)UILabel *lb_title;


@property (nonatomic, strong)UIButton *btn_next;

@property (nonatomic, strong)UIView *frontView;
@property (nonatomic, strong)UIImageView *img_back;
@property (nonatomic,strong)UILabel *lb_name;
@property (nonatomic, strong)UILabel *lb_cardId;



@end

@implementation SSTerminationViewController
#pragma mark - life cycle
- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    [self.view addSubview:self.backView];
    [self.view addSubview:self.backView_Name];
    [self.view addSubview:self.backView_IDNumber];
    [self.view addSubview:self.img_Example];
    [self.view addSubview:self.lb_Example];
    [self.view addSubview:self.lb_title];
    [self.view addSubview:self.leftLine];
    [self.view addSubview:self.rightLine];
    [self.view addSubview:self.btn_next];
    
    self.view.backgroundColor = [UIColor whiteColor];
    //起点发生变化
    //self.edgesForExtendedLayout=UIRectEdgeBottom;
    
    
    
    
    [self getOCR];
    
    
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self queryCardResult];
}

- (void)viewWillLayoutSubviews
{
    [super viewWillLayoutSubviews];
    
    [self.backView_Name mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.offset(45 * WIDTHRADIU +cl_kNavigationBarHeight);
        make.left.offset(20 * WIDTHRADIU);
        make.right.offset(-20 * WIDTHRADIU);
        make.height.offset(45 * WIDTHRADIU);
    }];
    [self.view_Name mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.bottom.right.offset(0);
    }];
    
    [self.subView_Name mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.top.bottom.offset(0);
        make.width.offset(65 * WIDTHRADIU);
    }];
    [self.img_Name mas_makeConstraints:^(MASConstraintMaker *make) {
        make.center.equalTo(self.subView_Name);
    }];
    
    [self.tf_Name mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.subView_Name.mas_right).offset(15 * WIDTHRADIU);
        make.top.bottom.offset(0);
        make.right.offset(-40 * WIDTHRADIU);
    }];
    
    
    
    [self.backView_IDNumber mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.backView_Name.mas_bottom).offset(20 * WIDTHRADIU);
        make.left.right.height.equalTo(self.backView_Name);
    }];
    
    [self.view_IDNumber mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.bottom.right.offset(0);
    }];
    
    [self.subView_IDNumber mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.top.bottom.offset(0);
        make.width.offset(65 * WIDTHRADIU);
    }];
    [self.img_IDNumber mas_makeConstraints:^(MASConstraintMaker *make) {
        make.center.equalTo(self.subView_IDNumber);
    }];
    
    [self.tf_IDNumber mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.subView_IDNumber.mas_right).offset(15 * WIDTHRADIU);
        make.top.bottom.offset(0);
        make.right.offset(-40 * WIDTHRADIU);
    }];
    
    [self.btn_scan mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.tf_IDNumber);
        make.left.equalTo(self.tf_IDNumber.mas_right).offset(7 * WIDTHRADIU);
    }];
    
    [self.img_Example mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.backView_IDNumber.mas_bottom).offset(44 * WIDTHRADIU);
        make.centerX.equalTo(self.backView_Name).offset(34 * WIDTHRADIU);
    }];
    
    [self.lb_Example mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.img_Example);
        make.right.equalTo(self.img_Example.mas_left).offset(-15 * WIDTHRADIU);
    }];
    
    [self.lb_title mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.backView);
        make.top.equalTo(self.img_Example.mas_bottom).offset(20 * WIDTHRADIU);
        make.height.offset(14 * WIDTHRADIU);
    }];
    
    [self.leftLine mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.lb_title);
        make.right.equalTo(self.lb_title.mas_left).offset(-12 * WIDTHRADIU);
        make.left.offset(18 * WIDTHRADIU);
        make.height.offset(0.5);
    }];
    [self.rightLine mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.lb_title);
        make.left.equalTo(self.lb_title.mas_right).offset(12 * WIDTHRADIU);
        make.right.offset(-18 * WIDTHRADIU);
         make.height.offset(0.5);
    }];
    
    [self.btn_next mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.backView.mas_bottom).offset(35 * WIDTHRADIU);
        make.left.offset(18 * WIDTHRADIU);
        make.right.offset(- 18 * WIDTHRADIU);
        make.height.offset(45 * WIDTHRADIU);
    }];
}

#pragma mark - UITextFieldDelegate
- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    return YES;
}

#pragma mark - SCNavigationControllerDelegate
- (void)sendIDCValue:(NSString *)name SEX:(NSString *)sex FOLK:(NSString *)folk BIRTHDAY:(NSString *)birthday ADDRESS:(NSString *) address NUM:(NSString *)num
{
    self.tf_Name.text =name;
    NSString *st1 =[num substringWithRange:NSMakeRange(0, 6)];
    NSString *st2 =[num substringWithRange:NSMakeRange(6, 4)];
    NSString *st3 =[num substringWithRange:NSMakeRange(10, 4)];
    NSString *st4 =[num substringFromIndex:14];
    self.tf_IDNumber.text =  [NSString stringWithFormat:@"%@ %@ %@ %@",st1,st2,st3,st4];
    
}


#pragma mark - event response
- (void)scanClick:(UIButton *)sendr
{
    SCCaptureCameraController *con = [[SCCaptureCameraController alloc] init];
    con.scNaigationDelegate = self;
    con.iCardType = TIDCARD2;
    con.isDisPlayTxt = YES;
    //con.TimeKey = TimeKeyS;
    con.ScanMode = TIDC_SCAN_MODE;
   
    [self presentViewController:con animated:YES completion:NULL];
}
- (void)nextStepClick:(UIButton *)sender
{
    if ([self.tf_Name.text length] <=0) {
        [SVProgressHUD showInfoWithStatus:@"请输入您的姓名!"];
        return;
    }
    NSString *newStr = [self.tf_IDNumber.text  stringByReplacingOccurrencesOfString:@" " withString:@""];
    BOOL IDCardInjudicious = [IDCardNumber_Validate isValidateIDCardString:newStr];
    if (!IDCardInjudicious) {
         [SVProgressHUD showErrorWithStatus:@"身份证上有格式上的错误"];
        return;
    }
    
    [self getSSCardSign];
    
}

- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event
{
    [self.view endEditing:YES];
}


#pragma mark - OCR
-(void)getOCR
{
#if TARGET_IPHONE_SIMULATOR
    
#else
    // 打开引擎
    Gint ret = 0;
    Gint vaule = 1;
    ret = TREC_StartUP(TREC_GetEngineTimeKEY());
    if (ret == 100) {
        return;
    }
    if (ret == 100) {
        return;
    }if (ret == 101) {
        return;
    }
    
    ret = TREC_SetParam(T_SET_HEADIMG, &vaule);
    ret = TREC_SetSupportEngine(TIDCARD2);// 演示使用身份证，其他证件以此类推
    
    UIImage *sdfasf;
    sdfasf=   TREC_GetHeadImage();// 获取人头像图片流
    
    if (ret != 1) {
        
        TREC_ClearUP();
        return;
    }
    
    
    ret = TREC_ClearUP();
#endif
    
    
    
    
}

#pragma mark - 电子社保卡请求
-(void)queryCardResult
{
    NSString *url = [NSString stringWithFormat:@"%@card/local",SSCardBaseUrl];
    
    NSDictionary *params = @{
                             @"userId":[NSNumber numberWithInteger:[getPeopleID PeopleID]]
                             };
    
 
    [SVProgressHUD show];
    [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
        [SVProgressHUD dismiss];
        
        if (error) {
            NSLog(@"%@",error);
            [SVProgressHUD showInfoWithStatus:@"网络异常"];
            return;
            
        }
        
        if (responseObject) {
            NSLog(@"电子社保卡responseObject:%@",responseObject);
            if ([responseObject[@"code"] isKindOfClass:[NSNumber class]]) {
                NSNumber *code = responseObject[@"code"];
                if (code.integerValue == 200) {
                    //如果返回的字符串不为空
                    if (![NSString blankString:responseObject[@"result"]]) {
                        
                        
                        [self queryCard:responseObject[@"result"]];
                        
                        return;
                    }else{
                        [self alertMessage];
                    }
                }else{
                    [SVProgressHUD showInfoWithStatus:@"网络异常"];
                }
            }else{
                [SVProgressHUD showInfoWithStatus:@"服务端异常"];
            }
            
            
        }
        
    }];
}

- (void)queryCard:(NSString *)auth_no
{
    
    NSString *url = [NSString stringWithFormat:@"%@card/query",SSCardBaseUrl];
    
    NSDictionary *params = @{
                             @"auth_no":auth_no
                             };
    [SVProgressHUD show];
    [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
        [SVProgressHUD dismiss];
        
        if (error) {
            NSLog(@"%@",error);
            [SVProgressHUD showInfoWithStatus:@"网络异常"];
            return;
            
        }
        
        if (responseObject) {
            if ([responseObject[@"code"] isKindOfClass:[NSNumber class]]) {
                NSNumber *code = responseObject[@"code"];
                
                NSLog(@"%@",responseObject);
                if (code.integerValue == 200) {
                    //如果返回的字符串不为空
                    if (![NSString blankString:responseObject[@"result"]]) {
                        
                        NSDictionary *dic = [self dictionaryWithJsonString:responseObject[@"result"]];
                        if ([dic[@"alipay_commerce_app_upload_response"][@"code"] isEqualToString:@"10000"]) {
                            NSDictionary *dic2 = [self dictionaryWithJsonString:dic[@"alipay_commerce_app_upload_response"][@"data"][@"response"]];
                            if (![NSString blankString:dic2[@"outUserCardNo"]]) {
                                [self.view addSubview:self.frontView];
                                self.lb_name.text = dic2[@"outUserName"];
                                self.lb_cardId.text = dic2[@"outUserCardNo"];
                                return;
                            }
                            
                        }
                        
                        [self alertMessage];
                        
                    }else{
                        
                    }
                }else{
                    [SVProgressHUD showInfoWithStatus:@"网络异常"];
                }
            }else {
                [SVProgressHUD showInfoWithStatus:@"服务端异常"];
                return;
            }
            
           
            
        }
        
    }];
}

//提醒
- (void)alertMessage
{
    
    NSString*sstermination = [[NSUserDefaults standardUserDefaults]objectForKey:@"sstermination"];
    if (!sstermination) {
        [self createAlterController];
    }
}
/*** 弹出对话框 */
- (void)createAlterController
{
    UIAlertController *alter = [UIAlertController alertControllerWithTitle:@"提示信息" message:@"只能绑定本人电子社保卡" preferredStyle:UIAlertControllerStyleAlert];
    //确定按钮的风格是默认的
    UIAlertAction *sure = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        NSLog(@"确定");
        
        [[NSUserDefaults standardUserDefaults]setObject:@"yes" forKey:@"sstermination"];
        [[NSUserDefaults standardUserDefaults]synchronize];
        //添加你自己让他发生的事件  都是一样的！！！！！
    }];
    //取消按钮的风格是取消， 并且一直在最下边，且只能有一个
    
    [alter addAction:sure];
    [self presentViewController:alter animated:YES completion:^{
        
    }];
}

- (void)getSSCardSign
{
    NSString *url = [[NSString stringWithFormat:@"%@card/sign",SSCardBaseUrl]  stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
       NSString *newStr = [self.tf_IDNumber.text  stringByReplacingOccurrencesOfString:@" " withString:@""];
    NSDictionary *params = @{
                             @"userId":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                             @"name":self.tf_Name.text,
                             @"idCard":newStr
                             };
    [SVProgressHUD show];
    
    [CTAPIBaseManager GET:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
        
        
        
        if (error) {
            NSLog(@"%@",error);
            [SVProgressHUD showInfoWithStatus:@"网络异常"];
            return;
            
        }
        
        if (responseObject) {
            
            if ([responseObject[@"code"] isKindOfClass:[NSNumber class]]) {
                NSNumber *code = responseObject[@"code"];
                NSString *msg = responseObject[@"msg"];
                
                NSLog(@"%@",responseObject);
                if (code.integerValue == 200) {
                    id result = responseObject[@"result"];
                    if ([result isKindOfClass:[NSString class]] && ![NSString blankString:result]) {
                        [self getBindUrlWithAuth_no:result];
                    }
                    
                }else{
                    [SVProgressHUD showInfoWithStatus:@"网络异常"];
                    return;
                }
            }else {
                [SVProgressHUD showInfoWithStatus:@"服务端异常"];
                return;
            }
            
           
        }
        
        [SVProgressHUD dismiss];
        
    }];
    
}

- (void)getBindUrlWithAuth_no:(NSString *)auth_no
{
    NSString *url = [NSString stringWithFormat:@"%@/card/bind",SSCardBaseUrl];
    
    NSDictionary *params = @{
                             @"auth_no":auth_no,
                             };
    
    [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
        
        if (error) {
            NSLog(@"%@",error);
            [SVProgressHUD showInfoWithStatus:@"网络异常"];
            return;
            
        }
        
        if ([responseObject[@"code"] isKindOfClass:[NSNumber class]]) {
            if (responseObject) {
                NSNumber *code = responseObject[@"code"];
                NSString *msg = responseObject[@"msg"];
                
                NSLog(@"%@",responseObject);
                if (code.integerValue == 200) {
                    
                    [SVProgressHUD dismiss];
                    
                    
                    id result = responseObject[@"result"];
                    if ([result isKindOfClass:[NSString class]] && ![NSString blankString:result]) {
                        NSString *res = result;
                        NSString *dataStr =[SecurityUtil decodeBase64String:res];
                        
                        [self jumpToHTML5:dataStr andJAnalytics:@"电子社保卡" JSString:dataStr];
                        
                        
                        
                    }
                    
                    
                    
                }else{
                    [SVProgressHUD showInfoWithStatus:@"网络异常"];
                    return;
                }
            }
        }else {
            [SVProgressHUD showInfoWithStatus:@"服务端异常"];
            return;
        }
        
      
        
    }];
}



#pragma mark - private methods

-(void)jumpToHTML5:(NSString*)url andJAnalytics:(NSString*)janalytics JSString:(NSString *)jsString
{
    UIStoryboard *sb  =[UIStoryboard storyboardWithName:@"Main" bundle:nil];
    WebViewController *tc=[sb instantiateViewControllerWithIdentifier:@"webViewController"];
    tc.hidesBottomBarWhenPushed =YES;
    tc.URL = [NSURL URLWithString:url];
    tc.janalytics = janalytics;
    tc.jsString = jsString;
    [self.navigationController pushViewController:tc animated:YES];
    
}
/// 添加四边阴影效果
- (void)addShadowToView:(UIView *)theView withColor:(UIColor *)theColor {
    // 阴影颜色
    theView.layer.shadowColor = theColor.CGColor;
    // 阴影偏移，默认(0, -3)
    theView.layer.shadowOffset = CGSizeMake(0,0);
    // 阴影透明度，默认0
    theView.layer.shadowOpacity = 0.5;
    // 阴影半径，默认3
    theView.layer.shadowRadius = 3;
    
}

- (NSDictionary *)dictionaryWithJsonString:(NSString *)jsonString {
    
    if (jsonString == nil) {
        
        return nil;
        
        
        
    }
    
    
    
    NSData *jsonData = [jsonString dataUsingEncoding:NSUTF8StringEncoding];
    
    NSError *err;
    
    NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:jsonData
                         
                                                        options:NSJSONReadingMutableContainers
                         
                                                          error:&err];
    
    if(err) {
        
        NSLog(@"json解析失败：%@",err);
        
        return nil;
        
    }
    
    return dic;
    
}

#pragma mark - getters and setters

- (XZDrawView *)backView
{
    if (!_backView ) {
        _backView = [[XZDrawView alloc]initWithFrame:CGRectMake(0, 0, ScreenWidth, 370 * WIDTHRADIU)];
        _backView.backgroundColor = [UIColor whiteColor];
         
    }
    return _backView;
}
- (UIView *)backView_Name
{
    if (!_backView_Name) {
        _backView_Name = [[UIView alloc]init];
        _backView_Name.backgroundColor = [UIColor clearColor];
        [self addShadowToView:_backView_Name withColor:[UIColor colorWithHex:0x1886d3]];
        [_backView_Name addSubview:self.view_Name];
    }
    return _backView_Name;
}
- (UIView *)view_Name
{
    if (!_view_Name) {
        _view_Name = [[UIView alloc]init];
        _view_Name.backgroundColor = [UIColor whiteColor];
        _view_Name.layer.cornerRadius = 5 * WIDTHRADIU;
        _view_Name.layer.masksToBounds = YES;
        [_view_Name addSubview:self.subView_Name];
        [_view_Name addSubview:self.tf_Name];
    }
    return _view_Name;
}

- (UIView *)subView_Name
{
    if (!_subView_Name) {
        _subView_Name = [[UIView alloc]init];
        _subView_Name.backgroundColor = [UIColor colorWithHex:0x1886d3];
        CAGradientLayer *gradientLayer =  [CAGradientLayer layer];
        gradientLayer.frame = CGRectMake(0, 0, 65 * WIDTHRADIU, 45 * WIDTHRADIU);
        gradientLayer.startPoint = CGPointMake(0, 1);
        gradientLayer.endPoint = CGPointMake(1, 0);
        //gradientLayer.locations = @[@(0),@(0.5)];//渐变点
        [gradientLayer setColors:@[(id)[[UIColor colorWithHex:0x2895f7] CGColor],(id)[[UIColor colorWithHex:0x1fa9e1] CGColor]]];//渐变数组
        [_subView_Name.layer addSublayer:gradientLayer];
        [_subView_Name addSubview:self.img_Name];
    }
    return _subView_Name;
}

- (UIImageView *)img_Name
{
    if (!_img_Name) {
        _img_Name = [[UIImageView alloc]init];
        _img_Name.image = [UIImage imageNamed:@"my_Socialsecuritytermination_deathcertificate_Name_normal"];
    }
    return _img_Name;
}

- (UITextField *)tf_Name
{
    if (!_tf_Name) {
        _tf_Name = [[UITextField alloc]init];
        _tf_Name.placeholder = @"请输入姓名";
        _tf_Name.borderStyle =  UITextBorderStyleNone;
        _tf_Name.backgroundColor = [UIColor clearColor];
        _tf_Name.delegate = self;
    }
    return _tf_Name;
}


- (UIView *)backView_IDNumber
{
    if (!_backView_IDNumber) {
        _backView_IDNumber = [[UIView alloc]init];
        _backView_IDNumber.backgroundColor = [UIColor clearColor];
        [self addShadowToView:_backView_IDNumber withColor:[UIColor colorWithHex:0x1886d3]];
        [_backView_IDNumber addSubview:self.view_IDNumber];
    }
    return _backView_IDNumber;
}
- (UIView *)view_IDNumber
{
    if (!_view_IDNumber) {
        _view_IDNumber = [[UIView alloc]init];
        _view_IDNumber.backgroundColor = [UIColor whiteColor];
        _view_IDNumber.layer.cornerRadius = 5 * WIDTHRADIU;
        _view_IDNumber.layer.masksToBounds = YES;
        [_view_IDNumber addSubview:self.subView_IDNumber];
        [_view_IDNumber addSubview:self.tf_IDNumber];
        [_view_IDNumber addSubview:self.btn_scan];
    }
    return _view_IDNumber;
}

- (UIView *)subView_IDNumber
{
    if (!_subView_IDNumber) {
        _subView_IDNumber = [[UIView alloc]init];
        _subView_IDNumber.backgroundColor = [UIColor colorWithHex:0x1886d3];
        CAGradientLayer *gradientLayer =  [CAGradientLayer layer];
        gradientLayer.frame = CGRectMake(0, 0, 65 * WIDTHRADIU, 45 * WIDTHRADIU);
        gradientLayer.startPoint = CGPointMake(0, 1);
        gradientLayer.endPoint = CGPointMake(1, 0);
        //gradientLayer.locations = @[@(0),@(0.5)];//渐变点
        [gradientLayer setColors:@[(id)[[UIColor colorWithHex:0x2895f7] CGColor],(id)[[UIColor colorWithHex:0x1fa9e1] CGColor]]];//渐变数组
        [_subView_IDNumber.layer addSublayer:gradientLayer];
        [_subView_IDNumber addSubview:self.img_IDNumber];
    }
    return _subView_IDNumber;
}

- (UIImageView *)img_IDNumber
{
    if (!_img_IDNumber) {
        _img_IDNumber = [[UIImageView alloc]init];
        _img_IDNumber.image = [UIImage imageNamed:@"my_Socialsecuritytermination_deathcertificate_IDnumber_normal"];
    }
    return _img_IDNumber;
}

- (UITextField *)tf_IDNumber
{
    if (!_tf_IDNumber) {
        _tf_IDNumber = [[UITextField alloc]init];
        _tf_IDNumber.placeholder = @"请输入身份证号";
        _tf_IDNumber.borderStyle =  UITextBorderStyleNone;
        _tf_IDNumber.backgroundColor = [UIColor clearColor];
        _tf_IDNumber.delegate = self;
    }
    return _tf_IDNumber;
}

- (UIButton *)btn_scan
{
    if (!_btn_scan) {
        _btn_scan = [UIButton buttonWithType:UIButtonTypeCustom];
        [_btn_scan setImage:[UIImage imageNamed:@"my_Socialsecuritytermination_deathcertificate_IDscanning_normal"] forState:UIControlStateNormal];
        [_btn_scan addTarget:self action:@selector(scanClick:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _btn_scan;
}

- (UILabel *)lb_Example
{
    if (!_lb_Example ) {
        _lb_Example = [[UILabel alloc]init];
        _lb_Example.text = @"例:";
        _lb_Example.font = [UIFont systemFontOfSize:19 * WIDTHRADIU];
        _lb_Example.textColor = [UIColor colorWithHex:0xb3b3b3];
    }
    return _lb_Example;
}

- (UIImageView  *)img_Example
{
    if (!_img_Example) {
        _img_Example = [[UIImageView alloc]init];
        _img_Example.image = [UIImage imageNamed:@"身份证图"];
    }
    return _img_Example;
}

- (UILabel *)lb_title
{
    if (!_lb_title) {
        _lb_title = [[UILabel alloc]init];
        _lb_title.font = [UIFont systemFontOfSize:14 * WIDTHRADIU];
        _lb_title.text = @"拍摄身份证，自动录入信息";
        _lb_title.textColor = [UIColor colorWithHex:0xb3b3b3];
        _lb_title.textAlignment = NSTextAlignmentCenter;
    }
    return _lb_title;
}

- (UIView *)leftLine
{
    if (!_leftLine) {
        _leftLine = [[UIView alloc]init];
        _leftLine.backgroundColor = [UIColor colorWithHex:0xb3b3b3];
    }
    return _leftLine;
}

- (UIView *)rightLine
{
    if (!_rightLine) {
        _rightLine = [[UIView alloc]init];
        _rightLine.backgroundColor = [UIColor colorWithHex:0xb3b3b3];
    }
    return _rightLine;
}

- (UIButton *)btn_next
{
    if (!_btn_next) {
        _btn_next = [UIButton buttonWithType:UIButtonTypeCustom];
        CAGradientLayer *gradientLayer =  [CAGradientLayer layer];
        gradientLayer.frame = CGRectMake(0, 0, ScreenWidth - 35 * WIDTHRADIU, 45 * WIDTHRADIU);
        gradientLayer.startPoint = CGPointMake(0, 0);
        gradientLayer.endPoint = CGPointMake(1, 0);
        //gradientLayer.locations = @[@(0),@(0.5)];//渐变点
        [gradientLayer setColors:@[(id)[[UIColor colorWithHex:0x2794f6] CGColor],(id)[[UIColor colorWithHex:0x1fabe1] CGColor]]];//渐变数组
        [_btn_next.layer addSublayer:gradientLayer];
        [_btn_next setTitle:@"下一步" forState:UIControlStateNormal];
        [_btn_next setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        _btn_next.titleLabel.font = [UIFont systemFontOfSize:16 * WIDTHRADIU];
       
        
        _btn_next.layer.cornerRadius = 10;
        _btn_next.layer.masksToBounds = YES;
        [_btn_next addTarget:self action:@selector(nextStepClick:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _btn_next;
}

- (UIView *)frontView
{
    if (!_frontView) {
        _frontView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, ScreenWidth, ScreenHeight - cl_kNavigationBarHeight)];
        _frontView.backgroundColor = [UIColor whiteColor];
        [_frontView addSubview:self.img_back];
        [_frontView addSubview:self.lb_name];
        [_frontView addSubview:self.lb_cardId];
        UIImage *image = [UIImage imageNamed:@"电子社保卡"];
        CGFloat scale = image.size.height/image.size.width;
        [self.img_back mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.offset(25 * WIDTHRADIU);
            make.right.offset(-25 * WIDTHRADIU);
            make.top.offset(15 * WIDTHRADIU);
            make.height.offset((ScreenWidth - 50 * WIDTHRADIU) * scale);
        }];
        [self.lb_name mas_makeConstraints:^(MASConstraintMaker *make) {
            make.top.offset(105 * WIDTHRADIU);
            make.left.offset(50 * WIDTHRADIU);
            make.height.offset(15 * WIDTHRADIU);
        }];
        
        [self.lb_cardId mas_makeConstraints:^(MASConstraintMaker *make) {
            make.top.equalTo(self.lb_name.mas_bottom).offset(10 * WIDTHRADIU);
            make.left.equalTo(self.lb_name);
            make.height.offset(15 * WIDTHRADIU);
        }];
    }
    return _frontView;
}

- (UIImageView *)img_back
{
    if (!_img_back) {
        _img_back = [[UIImageView alloc]init];
        _img_back.image = [UIImage imageNamed:@"电子社保卡"];
    }
    return _img_back;
}

- (UILabel *)lb_name
{
    if (!_lb_name) {
        _lb_name = [[UILabel alloc]init];
        _lb_name.text = @"姓       名:";
        _lb_name.textColor = [UIColor colorWithHex:0x0a457a];
        _lb_name.font = [UIFont systemFontOfSize:15 * WIDTHRADIU];
    }
    return _lb_name;
}

- (UILabel *)lb_cardId
{
    if (!_lb_cardId) {
        _lb_cardId  = [[UILabel alloc]init];
        _lb_cardId.text = @"社保卡号:";
        _lb_cardId.textColor = [UIColor colorWithHex:0x0a457a];
        _lb_cardId.font = [UIFont systemFontOfSize:15 * WIDTHRADIU];
    }
    return _lb_cardId;
}




/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
